package nl.naturalis.oaipmh.server.util;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.core.Response.Status;

import org.openarchives.oai._2.OAIPMHtype;
import org.openarchives.oai._2.VerbType;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import nl.naturalis.oaipmh.api.OaiProtocolException;
import nl.naturalis.oaipmh.api.OaiRepository;
import nl.naturalis.oaipmh.api.OaiRequest;
import nl.naturalis.oaipmh.api.util.OaiWriter;

import static org.openarchives.oai._2.VerbType.GET_RECORD;
import static org.openarchives.oai._2.VerbType.IDENTIFY;
import static org.openarchives.oai._2.VerbType.LIST_IDENTIFIERS;
import static org.openarchives.oai._2.VerbType.LIST_METADATA_FORMATS;
import static org.openarchives.oai._2.VerbType.LIST_RECORDS;
import static org.openarchives.oai._2.VerbType.LIST_SETS;
import static nl.naturalis.oaipmh.api.util.OaiUtil.createOAIPMHErrorResponse;
import static nl.naturalis.oaipmh.server.util.HttpResponses.plainTextResponse;

/**
 * Executes the appropriate method on an {@link OaiRepository} in "explain mode",
 * which will cause users to see the output of the loggers rather than the generated
 * OAI-PMH. (Actually the OAI-PMH output is appended after the output of the
 * loggers.)
 *
 * @author Ayco Holleman
 */
public final class OaiRequestDebugger {

  @SuppressWarnings("unused")
  private static final Logger logger = LoggerFactory.getLogger(OaiRequestDebugger.class);

  private final OaiRequest request;
  private final OaiRepository repo;
  private final String logLevel;

  public OaiRequestDebugger(OaiRequest request,
      OaiRepository repository,
      String logLevel) {
    this.request = request;
    this.repo = repository;
    this.logLevel = logLevel;
  }

  /**
   * Writes the OAI-PMH generated by the repository to the provided output stream.
   *
   * @return
   */
  public Response getResponse() {
    VerbType verb = request.getVerb();
    ByteArrayOutputStream out = new ByteArrayOutputStream(1024);
    ByteArrayOutputStream temp = new ByteArrayOutputStream(1024);
    try (LiveLogStream liveLog = new LiveLogStream(out, logLevel)) {
      if (verb == GET_RECORD) {
        repo.getRecord(temp);
      } else if (verb == IDENTIFY) {
        repo.identify(temp);
      } else if (verb == LIST_IDENTIFIERS) {
        repo.listIdentifiers(temp);
      } else if (verb == LIST_METADATA_FORMATS) {
        repo.listMetaDataFormats(temp);
      } else if (verb == LIST_RECORDS) {
        repo.listRecords(temp);
      } else if (verb == LIST_SETS) {
        repo.listSets(temp);
      }
      temp.writeTo(out);
      return plainTextResponse(out);
    } catch (OaiProtocolException e) {
      OAIPMHtype oaipmh = createOAIPMHErrorResponse(request, e.getErrors());
      OaiWriter writer = new OaiWriter();
      writer.write(oaipmh, out, true);
      return plainTextResponse(out);
    } catch (UnsupportedOperationException e) {
      new PrintWriter(out).println(HttpResponses.getMessage(Status.NOT_IMPLEMENTED,
          e.getMessage()));
      return plainTextResponse(Status.NOT_IMPLEMENTED, out);
    } catch (Throwable t) {
      t.printStackTrace(new PrintStream(out));
      return plainTextResponse(Status.INTERNAL_SERVER_ERROR, out);
    }
  }

}
